<template src="./template.html"></template>

<script lang="ts">
import { getModule } from "nuxt-property-decorator";
import { Vue, Component } from "vue-property-decorator";
import { apiErrorHandler } from "~/utils/apiHanlers";

@Component({})
export default class TwofaComponent extends Vue {
  loading = false;
  password = "";
  qrCode = "";
  code = "";
  isHidePassword = false;

  async onActive2Fa() {
    try {
      if (!this.password)
        return this.$pushNotification.error("Please enter your password");
      const response = await this.$api.user.turnOn2Fa(this.password);
      if (response?.data) {
        this.qrCode = response.data;
      }
      this.loading = true;
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
      this.isHidePassword = false;
    }
  }

  async onConfirm() {
    try {
      if (!this.password)
        return this.$pushNotification.error("Missing password");
      if (!this.code) return this.$pushNotification.error("Missing code");
      this.loading = true;
      await this.$api.user.verify2Fa(this.code, this.password);
      this.$store.dispatch("user/onGetMe", { ctx: this });
      this.$store.commit("user/setIsTwofa", true);
      this.qrCode = "";
      this.password = "";
      this.code = "";
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  async onInactive2Fa() {
    try {
      if (!this.password)
        return this.$pushNotification.error("Missing password");
      this.loading = true;
      await this.$api.user.turnOff2Fa(this.password);
      this.$store.dispatch("user/onGetMe", { ctx: this });
      this.password = "";
      this.$store.commit("user/setIsTwofa", false);
    } catch (error) {
      apiErrorHandler(error, this);
    } finally {
      this.loading = false;
    }
  }

  get isTwofa() {
    return this.$store.state?.user?.isTwofa || false;
  }
}
</script>

<style lang="scss" scoped></style>
